'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
//region Imports
var path = require('path');
var join = path.join;

var _ = require('lodash');
var cwd = require('cwd');
//endregion

exports.default = function (gulp, opts) {

  _.defaults(opts, {
    destDir: ''
  });

  var desc = 'Bootstraps module by modifying package.json and copying files from `babelator/templates` into module dir.';

  var babelatorContents = "// NOTE: Override `babelator/config` settings from here.\nmodule.exports = {}\n";

  gulp.task('babelator:bootstrap:config', function (done) {
    var replaceFile = require('../util/replaceFile');

    replaceFile(cwd('babelator.js'), babelatorContents, done);
  });

  gulp.task('babelator:bootstrap:pjson', function (done) {
    var modifyPackageJson = require('../util/modifyPackageJson');

    modifyPackageJson(function (json) {
      _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js');
      return json;
    }, done);
  });

  gulp.task('babelator:bootstrap', gulp.series('babelator:bootstrap:config', 'babelator:bootstrap:pjson'));
};

module.exports = exports['default'];