'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
//region Imports
var cwd = require('cwd');
var path = require('path');
//endregion

exports.default = function (gulp, opts) {

  // NOTE: Ordered by most time consuming.
  gulp.task('npm:prepublish', gulp.series('build', 'lint', 'mocha:lib:run'));
  gulp.task('npm:bootstrap:pjson', function (done) {
    var modifyPackageJson = require('../util/modifyPackageJson');
    var _ = require('lodash');

    modifyPackageJson(function (json) {
      _.set(json, 'scripts.prepublish', 'npm run gulp prepublish');
      _.set(json, 'main', path.join(opts.destDir, 'index.js'));
      _.set(json, 'license', 'MIT');
      return json;
    }, done);
  });
  gulp.task('npm:bootstrap:copy-files', function (done) {
    var replaceFile = require('../util/replaceFile');

    var contents = 'node_modules\n';
    replaceFile(cwd('.npmignore'), contents, done);
  });
  gulp.task('npm:bootstrap', gulp.series('npm:bootstrap:pjson', 'npm:bootstrap:copy-files'));
};

module.exports = exports['default'];