process.on('unhandledRejection', e => {throw e})

// TODO
// - Use init-package-json.
// - Use promises.

async function main() {

  //region Imports
  const fs = require('fs')
  const path = require('path')
  const cwd = require('cwd')
  const modifyPackageJson = require('./util/modifyPackageJson')
  const replaceFile = require('./util/replaceFile')
  const {spawnSync} = require('child_process')
  const init = require('init-package-json')
  const _ = require('lodash')
  const inquirer = require('inquirer')
  const {promisify} = require('bluebird')
  const Promise = require('bluebird')
  //endregion

  // npm init

  if (!fs.existsSync(cwd('package.json'))) {
    console.log('Initializing npm package...')
    spawnSync('npm init -f')
    //init(cwd(), 'package.json', {}, (e, data) => {
    //})
  }

  // gulp

  console.log('Adding gulp to package.json')

  await promisify(modifyPackageJson)(json => {
    _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js')
    return json
  })

  // gulpfile.js

  console.log('Updating gulpfile...')

  var gulpfileContents =
    "var gulp = require('gulp')\n" +
    "require('babelator')(gulp)\n"

  await promisify(replaceFile)(cwd('gulpfile.js'), gulpfileContents)

  // Add babelator dependency

  console.log('Adding babelator dependency...')

  const confirm = (message) => {
    return new Promise((resolve, reject) => {
      inquirer.prompt([{type: 'confirm', name: 'confirm', message}], (answers) => {
        resolve(answers)
      })
    })
  }

  // TODO(vjpr): Provide options instead of 2 confirms. Duh!
  let answers = null
  answers = await confirm('Run `npm i -D babelator gulpjs/gulp.git#4.0`?')
  if (answers.confirm) {
    spawnSync('npm', ['i', '-D', 'babelator', 'gulpjs/gulp.git#4.0'], {stdio: 'inherit'})
  } else {
    answers = await confirm('Run `npm link -D babelator gulp`?')
    if (answers.confirm)
      spawnSync('npm', ['link', 'babelator', 'gulp'], {stdio: 'inherit'})
  }
  // Instructions
  console.log('Please run `npm install`')
  console.log('Please run `npm install`')
  console.log('Tip: Use `npm_lazy` module to locally cache npm modules.')

}

function cli() {
  main().then(() => {})
}

module.exports = cli
